Page MenuHomePhabricator

Workboards should be a full application
Closed, WontfixPublic

Description

We're going to limited to what they are and what they do, as long as their buried inside Projects. We should just make it a full application. The main idea here is I want an easy way to 'dock' different projects like tabs and just be able to move between them while still in board-mode.

Event Timeline

chad updated the task description. (Show Details)Apr 24 2014, 3:09 AM
chad added a project: Workboards.
chad added subscribers: chad, btrahan, epriestley.
chad created this task.
chad raised the priority of this task from to Normal.

I already have a mock in my head, but will wait on overall feedback. But, i know you guys love apps.

I'd like to flesh this out a bit more before committing to it, but I'm generally open to it. Two things that came up somewhere:

  • workboard of a user's tasks (vs a project's tasks)
  • workboard of projects (vs tasks)

Not really convinced either of these are like super great ideas, but they're off the table with boards inside projects.

On the other hand, workboards probably have a better chance of interacting sensibly with subprojects if they remain closely tied to projects, but that's not very well fleshed out either.

chad added a comment.Apr 24 2014, 5:13 AM

My rough though (before I get Balsamiq out) is that we have both the sub-projects task and the swamp of suck homepage task ahead of making workboards more accessible/workable for various people. I think if we approached it more on a meta-container level, we could build something that would meet all needs before those other tasks.

Alpha:
By default "Workboards" is an app which shows you a tabbed interface at the top with projects you are a member of. You can reorder the tabs, and the first tab is the Workboard default. Each tab below show's that projects workboard.

Beta:
People can make other "Workspaces" in Workboards which are sets of Projects. This allows managerial types to have groupings of projects they may want to watch, but don't belong to. You might have an "F8" Workspace that tracks all the Projects launching at your companies F8 conference. Another example is Sprints. You could have "Maniphest" be your Workspace and "Maniphest.S1", "Maniphest.S2", "Maniphest.S3" as your Projects.

v1:
Additional Board Types like "Personal", where I can move my tasks to how they relate to me personally. As in, stuff Im working on now, upcoming, backlog.

@chad - on your alpha, how do you think about the "choose which project / workboard" UI when the user is a member of N projects where N is fairly large? Evan probably has the right N to stress test it on this instance today.

I like the alpha -> beta. I'd probably just call "workspaces" "workboards" though, and potentially for v1 allow ways to define them beyond even just projects. (e.g. values of custom fields on the tasks.)

What if Chad's thoughts on https://secure.phabricator.com/T4890#6 were instead implemented as a default view on Maniphest? (i.e. application search is something you have to click through to, and otherwise its this more boards-based view?) We can put some of the existing default application search items as automagic workboards (as in Chad's mock) / make it easy to make workboards that show those search results in workboard form.

I guess the question to me is maybe the existing "list of tasks" UI is not particularly useful / a 1 column board, and its better to just always be looking at a board?

I like the workspace bit a bunch, particular if it lets us get away with "workspaces" and "projects" (and not need subprojects. I think we might need to work on custom fields a tad more usability / discoverability wise to iron out the other subproject needs.) Someting like T4893 may be solvable here too.

If we plan on keeping workspace + maniphest as fairly distinct, I think its important we don't pollute the project namespace for either use case. For example, if it makes sense to be adding projects like "Maniphest.Sprint5" in workboards, I'd want those projects to feel correct while using maniphest. Not sure if it would be a problem as layed out; just a consideration I want to keep in mind.

chad added a comment.EditedApr 26 2014, 10:34 PM

@btrahan, I'd solve it both in the UI (with tabs that collapse at the end into a dropdown) and with "Workboards" (Project Buckets inside the Workboard app). I'm leaning towards just a full-fledged product management app that ties into every other application rather than stay buried in Projects. I think it's both more intuitive to have a separate space, and something that will allow more flexibility. I have minor concerns Projects in general are getting overloaded and this would keep them separate.

chad added a subscriber: qgil.Apr 26 2014, 10:34 PM
qgil added a comment.Apr 27 2014, 6:51 AM

Just a simple suggestion for now: calling them "Boards".

chad added a comment.Apr 27 2014, 1:34 PM

There is some history to how things get named, even if we're not always consistent.
https://www.quora.com/Phabricator/Why-is-the-Browse-feature-called-Diffusion-and-not-just-Browse

@chad - I agree on elevating it from projects. What are your thoughts on replacing / merging the Maniphest task list UI with the workboard UI, etc. from my comment?

(I haven't thought about this carefully, but another possible attack here is making a "dock" widget and a "board" widget and driving this through dashboards, although that might create a bunch of other problems.)

chad added a comment.EditedApr 27 2014, 7:16 PM

I think the benefits to a solo application outweigh the downsides. Actually, I'm not sure there is any downside since I think eng/design costs are lighter.

  • With a full app, we can truly focus on "Product Management" in one place
  • We don't need to make compromises in other apps to support all community feedback

For example, making it the default in Maniphest both disrupts how the community currently works there and loosely ties Workboards directly to Task Objects only (or mostly). T2628 comes to mind specifically. I can see wanting other Object Types on Workboards. I think Atlassian allows diffs to be on their boards. Why not have Workboards for Pholio? It might happen.

Adding to homepage (shortcuts to boards) should happen anyways, I don't think this would impact that. I think design/eng time on a homepage is probably pretty great if we want to do it well. At least on my end.

Adding to Projects or making it a default view of Projects is possible, but if we called Projects the more aptly named "Tags", I don't know that we would do that. This is my concern on limiting applications, Projects should be about managing the containers, not building weekly Sprints.

Uninstallable. Don't want it? Cool, uninstalled.

I think I may be able to rough my concept out with a little stretch of time, at least I'd rather discuss this over a working Alpha design to see what the feedback would be like. I think just an app, and a sidebar of your projects is all that's needed to feel this out.

iPublicis added a subscriber: iPublicis.EditedApr 27 2014, 10:25 PM

Hi there,

I'm more used to work with Atallassian Jira and GreenHopper (now Agile).
What I think would be just great would be to have something like that in Phabricator.

https://marketplace.atlassian.com/plugins/com.pyxis.greenhopper.jira

Just my 2¢ :)

fsilva added a subscriber: fsilva.Apr 27 2014, 11:01 PM
noisy added a subscriber: noisy.May 21 2014, 9:08 PM
mim added a subscriber: mim.Jul 17 2014, 1:21 PM
qgil added a comment.EditedOct 7 2014, 11:48 AM
In T4890#56097, @chad wrote:

Additional Board Types like "Personal", where I can move my tasks to how they relate to me personally. As in, stuff Im working on now, upcoming, backlog.

I have seen you mentioning this Personal workboard in a couple of places. Has this idea a task on its own? I couldn't find it. It's a very good idea.

Right after announcing Wikimedia Phabricator registration open for everyone, we got already this request from one of our developers: https://phabricator.wikimedia.org/T555

witrin added a subscriber: witrin.
jdloft added a subscriber: jdloft.Mar 11 2015, 2:11 AM
ksmith added a subscriber: ksmith.Mar 27 2015, 5:04 PM
paks87 added a subscriber: paks87.Apr 23 2015, 8:13 AM
clloos added a subscriber: clloos.Dec 11 2015, 10:29 AM
chad closed this task as Wontfix.Dec 24 2015, 4:41 PM
chad claimed this task.
urzds added a subscriber: urzds.Jul 12 2017, 11:13 AM